//
// MobileNet.m
//
// This file was automatically generated and should not be edited.
//

#import "MobileNet.h"

@implementation MobileNetInput

- (instancetype)initWithImage:(CVPixelBufferRef)image {
    if (self) {
        _image = image;
    }
    return self;
}

- (NSSet<NSString *> *)featureNames {
    return [NSSet setWithArray:@[@"image"]];
}

- (nullable MLFeatureValue *)featureValueForName:(NSString *)featureName {
    if ([featureName isEqualToString:@"image"]) {
        return [MLFeatureValue featureValueWithPixelBuffer:_image];
    }
    return nil;
}

@end

@implementation MobileNetOutput

- (instancetype)initWithClassLabelProbs:(NSDictionary<NSString *, NSNumber *> *)classLabelProbs classLabel:(NSString *)classLabel {
    if (self) {
        _classLabelProbs = classLabelProbs;
        _classLabel = classLabel;
    }
    return self;
}

- (NSSet<NSString *> *)featureNames {
    return [NSSet setWithArray:@[@"classLabelProbs", @"classLabel"]];
}

- (nullable MLFeatureValue *)featureValueForName:(NSString *)featureName {
    if ([featureName isEqualToString:@"classLabelProbs"]) {
        return [MLFeatureValue featureValueWithDictionary:_classLabelProbs error:nil];
    }
    if ([featureName isEqualToString:@"classLabel"]) {
        return [MLFeatureValue featureValueWithString:_classLabel];
    }
    return nil;
}

@end

@implementation MobileNet

- (nullable instancetype)initWithContentsOfURL:(NSURL *)url error:(NSError * _Nullable * _Nullable)error {
    self = [super init];
    if (!self) { return nil; }
    _model = [MLModel modelWithContentsOfURL:url error:error];
    if (_model == nil) { return nil; }
    return self;
}

- (nullable instancetype)init {
    NSString *assetPath = [[NSBundle bundleForClass:[self class]] pathForResource:@"MobileNet" ofType:@"mlmodelc"];
    return [self initWithContentsOfURL:[NSURL fileURLWithPath:assetPath] error:nil];
}

- (nullable MobileNetOutput *)predictionFromFeatures:(MobileNetInput *)input error:(NSError * _Nullable * _Nullable)error {
    id<MLFeatureProvider> outFeatures = [_model predictionFromFeatures:input error:error];
    MobileNetOutput * result = [[MobileNetOutput alloc] initWithClassLabelProbs:(NSDictionary<NSString *, NSNumber *> *)[outFeatures featureValueForName:@"classLabelProbs"].dictionaryValue classLabel:[outFeatures featureValueForName:@"classLabel"].stringValue];
    return result;
}

- (nullable MobileNetOutput *)predictionFromImage:(CVPixelBufferRef)image error:(NSError * _Nullable * _Nullable)error {
    MobileNetInput *input_ = [[MobileNetInput alloc] initWithImage:image];
    return [self predictionFromFeatures:input_ error:error];
}

@end
